/*
** Gobbledegook
** A very simple letter scrambler that keeps the first and last letter of words the same, and a few other tweeks
*/

#Include Anchor.ahk

prefixToKeep=Mc|Mac
subWordBreak=|'|-
quote='
dash=-

Gui, +Resize +MinSize356x91
Gui, font, s11, Verdana
Gui, Add, Edit, x7 y10 w340 r1 vGobbleThis,
Gui, Add, Edit, x6 y40 w340 r10 vGobbledText ReadOnly,
Gui, Add, Button, Default gGobbleThis xp yp vGobbleButton, GobbleThis
GuiControl, Hide, GobbleButton
; Generated using SmartGUI Creator 4.0
Gui, Show, x131 y91 w356, Gobbledegook
Return

GuiSize:
Anchor("GobbleThis","w")
Anchor("GobbledText", "wh")
Return

GuiClose:
ExitApp

GobbleThis:
GUI, Submit , NoHide
if GobbleThis
{
	stringOutput=
	Loop, Parse, GobbleThis ,%A_Space% ,
	{
	  subWord=
	  thisWord:=A_LOOPFIELD
	  Loop, Parse, thisWord, , 
     {
      if (A_LOOPFIELD=dash) 
      {
        stringOutput .= GobbleThisWord(subWord) . dash
        subWord=
      } else if (A_LOOPFIELD=quote)
      {
        stringOutput .= GobbleThisWord(subWord) . quote
        subWord= 
      } else if (A_LOOPFIELD="")
      {
        stringOutput .= GobbleThisWord(subWord) . ""
        subWord= 
      } else
      {
        subWord.=A_LOOPFIELD
        if (A_INDEX = StrLen(thisWord))
        {
          stringOutput .= GobbleThisWord(subWord) . A_Space
          subWord=
        }
      }
     }
    ;stringOutput .=  subWord . A_Space
	}
	StringTrimRight, stringOutput, stringOutput, 1
  stringOutput:= stringOutput . "`n"
}

newGobbledText:= stringOutput . GobbledText
GuiControl, , GobbledText , %newGobbledText%
GuiControl, , GobbleThis,
Return

GobbleThisWord(thisWord)
{
	global prefixToKeep, quote
	
	stringPrefix=
	stringSufix=
	stringBody=
	donePrefix:=False
	doneAlphaPrefix:=False
	startBody:=0
	startPrefix:=1
	
	lengthThisWord:=StrLen(thisWord)
  Loop %lengthThisWord%
  {
    checkCharacter:= lengthThisWord - A_INDEX + 1
    checkThis:=substr(thisWord , checkCharacter , 1)
    checkNext:=substr(thisWord , checkCharacter-1 , 1)
    If checkThis is alnum
			{
				if (checkNext != quote)
        	break
   		}
  }

  Loop, Parse, thisWord 
  {
		if A_LOOPFIELD is alnum
		{
			startPrefix:=A_INDEX
			break
		}
  }
  
	Loop, Parse, prefixToKeep , |, 
	{
		if ( substr( thisWord , startPrefix , StrLen(A_LOOPFIELD) ) = A_LOOPFIELD )
		{
		  stringPrefix:=substr( thisWord , 1 , StrLen(A_LOOPFIELD)+ startPrefix )
		  donePrefix:=true
		  startBody:=StrLen(A_LOOPFIELD)+startPrefix
			break
		}
	}
  Loop, Parse, thisWord 
  {
    if not donePrefix
    {
			if (A_LOOPFIELD is alnum and doneAlphaPrefix)
			{
			  donePrefix=True
			  stringBody.=A_LOOPFIELD
			} else {
				stringPrefix.=A_LOOPFIELD
				if A_LOOPFIELD is Alpha
					doneAlphaPrefix:=True
			}
		} else {
		  if (A_INDEX>=checkCharacter)
		  {
				stringSufix.= A_LOOPFIELD
			} else
			{
			  if (A_INDEX>startBody)
					stringBody.= "|" . A_LOOPFIELD
			}
		}
  }
  Sort, stringBody , RANDOM D|
  Loop, Parse, stringBody , |, 
  {
		stringGobbled.= A_LOOPFIELD
  }
  Return stringPrefix . stringGobbled . stringSufix
}
